#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Orange
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
//----
extern string TimeFrame = "Current time frame";
extern int Range = 9;
extern int FastMA = 2;
extern int SlowMA = 30;
extern int filter = 25;
extern int PriceMaPeriod = 5;
extern int PriceMaMethod = 1;
extern int PriceMaPrice  = PRICE_CLOSE;
//----
double Downa[];
double Downb[];
double trend[];
double fAMA[];
double mAMA[];
double AMA[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);
   SetIndexBuffer(0, fAMA);
   SetIndexBuffer(1, Downa); 
   SetIndexBuffer(2, Downb); 
   SetIndexBuffer(3, trend); 
   SetIndexBuffer(4, mAMA);
   SetIndexBuffer(5, AMA);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         timeFrame         = stringToTimeFrame(TimeFrame);
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { fAMA[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period())
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               if (trend[limit]==-1) CleanPoint(limit,Downa,Downb);
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     fAMA[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Range,FastMA,SlowMA,filter,PriceMaPeriod,PriceMaMethod,PriceMaPrice,0,y);
                     trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Range,FastMA,SlowMA,filter,PriceMaPeriod,PriceMaMethod,PriceMaPrice,3,y);
                     Downa[i] = EMPTY_VALUE;
                     Downb[i] = EMPTY_VALUE;
                     if (trend[i]==-1) PlotPoint(i,Downa,Downb,fAMA);
               }
               return(0);
           }
   //int counted_bars = IndicatorCounted();
   int cb;
   double  k1, k2, Noise, ER, SSC, sdAMA, dAMA;
//----

       k1 = 2.0 / (SlowMA + 1);
       k2 = 2.0 / (FastMA + 1) - k1;
       //----
       for(cb = limit; cb >= 0; cb--)
         {
           Noise = 0;
           //----
           for(i = cb; i <= cb + Range - 1; i++)
             {
               Noise = Noise + MathAbs(iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,i) - iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,i+1));
             }
           //----
           if(Noise != 0)
             {
               ER = MathAbs(iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,cb) - iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,cb+Range)) / Noise;
             }
           else
             {
               ER = 0;
             }
           SSC = (ER*k2 + k1);
           AMA[cb] = AMA[cb+1] + NormalizeDouble(SSC*SSC*(iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,cb) - AMA[cb+1]), 4);
           mAMA[cb] = AMA[cb];
           //----
           if(filter < 1)
             {
               fAMA[cb] = mAMA[cb];
             }
           else
             {
               for(i = cb; i <= cb + SlowMA - 1; i++)
                 {
                   sdAMA = sdAMA + MathAbs(mAMA[i] - mAMA[i+1]);
                 }
               dAMA = mAMA[cb] - mAMA[cb+1];
               //----
               if(dAMA >= 0)
                 {
                   if(dAMA < NormalizeDouble(filter*sdAMA / (100*SlowMA), 4) && 
                      High[cb] <= High[Highest(NULL, 0, MODE_HIGH, 4, cb)] + 10*Point)
                     {
                       fAMA[cb] = fAMA[cb+1];
                     }
                   else
                     {
                       fAMA[cb] = mAMA[cb];
                     }
                 }
               else
                 {
                   if(MathAbs(dAMA) < NormalizeDouble(filter*sdAMA / (100*SlowMA), 4) && 
                      Low[cb] > Low[Lowest(NULL, 0, MODE_LOW, 4, cb)] - 10*Point)
                     {
                       fAMA[cb] = fAMA[cb+1];
                     }
                   else
                     {
                       fAMA[cb] = mAMA[cb];
                     }
                 }
               sdAMA=0.0;
             }
         }
//----     

   if (trend[limit]==-1) CleanPoint(limit,Downa,Downb);
   for (i=limit; i>=0; i--)
   {
      Downa[i] = EMPTY_VALUE;
      Downb[i] = EMPTY_VALUE;
    
        trend[i] = trend[i+1];
           if (fAMA[i]> fAMA[i+1]) trend[i] =1;
           if (fAMA[i]< fAMA[i+1]) trend[i] =-1;
       if (trend[i]==-1) PlotPoint(i,Downa,Downb,fAMA);
   }
   return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}   